#include "StdAfx.h"
#include "NeMessenger.h"
#include "TimerManager.h"

IMPLEMENT_DYNAMIC(CTimerManager, CWnd)

CTimerManager::CTimerManager(void)
{
	
}

CTimerManager::~CTimerManager(void)
{
	
}

BEGIN_MESSAGE_MAP(CTimerManager, CWnd)
	ON_WM_TIMER()
END_MESSAGE_MAP()

// CTimerManagerWnd ޽ óԴϴ.

void CTimerManager::Initialize(void)
{
	SetTimer(TIMER_MANAGER_CHECK, 1000 * 60, NULL);
}

void CTimerManager::Deinitialize(void)
{
	KillTimer(TIMER_MANAGER_CHECK);
}

UINT_PTR CTimerManager::SetManagedTimer(CWnd* pWnd, UINT_PTR nTimerID, UINT nElapse/*, void (CALLBACK *lpfnTimer)()*/)
{
	if( pWnd == NULL )
		return 0;

	// Already started timer?
	map<UINT_PTR, CTimer>::iterator itr = m_mapManagedTimer.find(nTimerID);
	if( itr != m_mapManagedTimer.end() )
		return itr->second.m_nTimerID;

	// Add and start timer
	CTimer timer(pWnd, nTimerID, nElapse/*, lpfnTimer*/);
	timer.m_timeLastCaused = CTime::GetCurrentTime();
	m_mapManagedTimer.insert(make_pair(nTimerID, timer));
	pWnd->SetTimer(nTimerID, nElapse, NULL);

	return UINT_PTR();
}

BOOL CTimerManager::KillManagedTimer(CWnd* pWnd, UINT_PTR nTimerID)
{
	// KillTimer
	pWnd->KillTimer(nTimerID);

	// Remove TimerObj
	map<UINT_PTR, CTimer>::iterator itr = m_mapManagedTimer.find(nTimerID);
	if( itr != m_mapManagedTimer.end() )
		m_mapManagedTimer.erase(itr);

	return TRUE;
}

void CTimerManager::OccuredTimerEvent(UINT_PTR nTimerID)
{
	map<UINT_PTR, CTimer>::iterator itr = m_mapManagedTimer.find(nTimerID);
	if( itr != m_mapManagedTimer.end() )
		itr->second.m_timeLastCaused = CTime::GetCurrentTime();
}

void CTimerManager::OnTimer(UINT_PTR nIDEvent)
{
	if( TIMER_MANAGER_CHECK == nIDEvent )
	{
		map<UINT_PTR, CTimer>::iterator itr = m_mapManagedTimer.begin();
		for(; itr != m_mapManagedTimer.end(); itr++)
		{
			CTime timeNow(CTime::GetCurrentTime());
			CTimeSpan timeSpan = timeNow - itr->second.m_timeLastCaused;

			// check timer is stopped
			LONGLONG lSec = timeSpan.GetTotalSeconds();
			if( itr->second.m_nElapse * 3 < lSec * 1000 )
			{
				// restart timer
				itr->second.m_timeLastCaused = CTime::GetCurrentTime();
				itr->second.RestartTimer();
			}
		}
	}

	CWnd::OnTimer(nIDEvent);
}
